c
      subroutine icnvlt(dt,L,gi3,difi,U)
      parameter(Lmax=64,Lma=4*Lmax*(Lmax+1))
      dimension dt(L+1,L+1,2*L+2),gi3(L+1,L+1,L+1),difi(L+1,L+1,L+1)
      dimension ts11(4*Lmax),ts12(4*Lmax),ts21(4*Lmax),ts22(4*Lmax)
      dimension tmp1(Lma),tmp2(Lma)
      double precision tpiN,sr,cr,snr,cnr,tmp
c
c *****Must preprocess difi for correct energies*****
c **** L=2^n ****
c
      if(L.gt.Lmax)stop 'icnvl array error'
c
      L2=2*L
      Lp1=L+1
      tpiN=6.28318530717959d0/float(L2)
      snr=sin(tpiN)
      cnr=-2.0d0*sin(0.5d0*tpiN)**2
c
c Transform lines parallel to z
c
      U=0.
      do 100 iy=1,Lp1
       do 100 ix=1,Lp1
c
        do 101 iz=1,Lp1
         ts11(iz)=dt(ix,iy,iz)
         ts11(iz+L-1)=0.
 101    continue
        call fourn(ts11,L,1,1)
        do 102 iz=1,L2
 102    dt(ix,iy,iz)=ts11(iz)
c
 100  continue
c
c **** Do planes two at a time ****
c
      sr=0.
      cr=1.
      do 200 iz=1,L/2+1
       icz=mod(L-iz+1,L)+1
       igz=L-iz+2
       inz=2*iz-1
       incz=2*icz-1
c
       do 201 i=1,Lma
        tmp1(i)=0.
        tmp2(i)=0.
 201   continue
c
       do 202 iy=1,Lp1
        do 202 ix=1,Lp1
         i=ix+(iy-1)*L2
         nr=2*i-1
         ni=nr+1
         tmp1(nr)=dt(ix,iy,inz)
         tmp1(ni)=dt(ix,iy,inz+1)
         tmp2(nr)=dt(ix,iy,incz)
         tmp2(ni)=dt(ix,iy,incz+1)
 202   continue
c
       do 203 iy=1,Lp1
        i=2*(iy-1)*L2+1
        call fourn(tmp1(i),L2,1,1)
        call fourn(tmp2(i),L2,1,1)
 203   continue
c
       S=sr
       C=cr
       do 204 ix=1,Lp1
        icx=mod(L2-ix+1,L2)+1
        igx=min(L2+2-ix,ix)
c
        do 205 i=1,2*L2
         ts11(i)=0.
         ts12(i)=0.
         ts21(i)=0.
         ts22(i)=0.
 205    continue
c
        do 206 iy=1,Lp1
         i1=ix+(iy-1)*L2
         i2=icx+(iy-1)*L2
         nyr=2*iy-1
         nyi=nyr+1
         n1r=2*i1-1
         n1i=n1r+1
         n2r=2*i2-1
         n2i=n2r+1
         ts11(nyr)=tmp1(n1r)
         ts11(nyi)=tmp1(n1i)
         ts12(nyr)=tmp1(n2r)
         ts12(nyi)=tmp1(n2i)
         ts21(nyr)=tmp2(n1r)
         ts21(nyi)=tmp2(n1i)
         ts22(nyr)=tmp2(n2r)
         ts22(nyi)=tmp2(n2i)
 206    continue
        call fourn(ts11,L2,1,1)
        call fourn(ts12,L2,1,1)
        call fourn(ts21,L2,1,1)
        call fourn(ts22,L2,1,1)
c
        do 207 iy=1,Lp1
         icy=mod(L2-iy+1,L2)+1
         igy=min(L2+2-iy,iy)
         n0r=2*iy-1
         n0i=n0r+1
         n1r=2*icy-1
         n1i=n1r+1
c
         dsum=difi(igx,igy,iz)+difi(igx,igy,igz)
         ddif=difi(igx,igy,iz)-difi(igx,igy,igz)
         da=dsum+S*ddif
         db=2.*C*ddif
         dc=dsum-S*ddif
         U=U+(ts11(n0r)**2+ts11(n0i)**2
     x      + ts11(n1r)**2+ts11(n1i)**2
     x      + ts12(n0r)**2+ts12(n0i)**2
     x      + ts12(n1r)**2+ts12(n1i)**2)*da
c
     x      +(ts11(n0r)*ts22(n1i)+
     x        ts11(n0i)*ts22(n1r)
     x      + ts11(n1r)*ts22(n0i)+
     x        ts11(n1i)*ts22(n0r)
     x      + ts12(n0r)*ts21(n1i)+
     x        ts12(n0i)*ts21(n1r)
     x      + ts12(n1r)*ts21(n0i)+
     x        ts12(n1i)*ts21(n0r))*db
c
     x      +(ts21(n0r)**2+ts21(n0i)**2
     x      + ts21(n1r)**2+ts21(n1i)**2
     x      + ts22(n0r)**2+ts22(n0i)**2
     x      + ts22(n1r)**2+ts22(n1i)**2)*dc
c
         gsum=0.5*(gi3(igx,igy,iz)+gi3(igx,igy,igz))
         gdif=0.5*(gi3(igx,igy,iz)-gi3(igx,igy,igz))
         ga=gsum+S*gdif
         gb=C*gdif
         gc=gsum-S*gdif
         d00r1=ts11(n0r)*ga+ts22(n1i)*gb
         d00i1=ts11(n0i)*ga+ts22(n1r)*gb
         d01r1=ts11(n1r)*ga+ts22(n0i)*gb
         d01i1=ts11(n1i)*ga+ts22(n0r)*gb
         d10r1=ts12(n0r)*ga+ts21(n1i)*gb
         d10i1=ts12(n0i)*ga+ts21(n1r)*gb
         d11r1=ts12(n1r)*ga+ts21(n0i)*gb
         d11i1=ts12(n1i)*ga+ts21(n0r)*gb
         d00r2=ts21(n0r)*gc+ts12(n1i)*gb
         d00i2=ts21(n0i)*gc+ts12(n1r)*gb
         d01r2=ts21(n1r)*gc+ts12(n0i)*gb
         d01i2=ts21(n1i)*gc+ts12(n0r)*gb
         d10r2=ts22(n0r)*gc+ts11(n1i)*gb
         d10i2=ts22(n0i)*gc+ts11(n1r)*gb
         d11r2=ts22(n1r)*gc+ts11(n0i)*gb
         d11i2=ts22(n1i)*gc+ts11(n0r)*gb
         ts11(n0r)=d00r1
         ts11(n0i)=d00i1
         ts11(n1r)=d01r1
         ts11(n1i)=d01i1
         ts12(n0r)=d10r1
         ts12(n0i)=d10i1
         ts12(n1r)=d11r1
         ts12(n1i)=d11i1
         ts21(n0r)=d00r2
         ts21(n0i)=d00i2
         ts21(n1r)=d01r2
         ts21(n1i)=d01i2
         ts22(n0r)=d10r2
         ts22(n0i)=d10i2
         ts22(n1r)=d11r2
         ts22(n1i)=d11i2
 207    continue
        call fourn(ts11,L2,1,-1)
        call fourn(ts12,L2,1,-1)
        call fourn(ts21,L2,1,-1)
        call fourn(ts22,L2,1,-1)
c
        do 208 iy=1,Lp1
         i1=ix+(iy-1)*L2
         i2=icx+(iy-1)*L2
         nyr=2*iy-1
         nyi=nyr+1
         n1r=2*i1-1
         n1i=n1r+1
         n2r=2*i2-1
         n2i=n2r+1
         tmp1(n1r)=ts11(nyr)
         tmp1(n1i)=ts11(nyi)
         tmp1(n2r)=ts12(nyr)
         tmp1(n2i)=ts12(nyi)
         tmp2(n1r)=ts21(nyr)
         tmp2(n1i)=ts21(nyi)
         tmp2(n2r)=ts22(nyr)
         tmp2(n2i)=ts22(nyi)
 208    continue
c
 204   continue
       tmp=sr
       sr=sr*cnr+cr*snr+sr
       cr=cr*cnr-tmp*snr+cr
c
       do 209 iy=1,Lp1
        i=2*(iy-1)*L2+1
        call fourn(tmp1(i),L2,1,-1)
        call fourn(tmp2(i),L2,1,-1)
 209   continue
c       
       do 210 iy=1,Lp1
        do 210 ix=1,Lp1
         i=ix+(iy-1)*L2
         nr=2*i-1
         ni=nr+1
         dt(ix,iy,inz)=tmp1(nr)
         dt(ix,iy,inz+1)=tmp1(ni)
         dt(ix,iy,incz)=tmp2(nr)
         dt(ix,iy,incz+1)=tmp2(ni)
 210   continue
c
 200  continue
c
c **** Inverse transform lines parallel to z ****
c
      do 300 iy=1,Lp1
       do 300 ix=1,Lp1
c
        do 301 iz=1,L2
         ts11(iz)=dt(ix,iy,iz)
 301    continue
        call fourn(ts11,L,1,-1)
        do 302 iz=1,Lp1
 302    dt(ix,iy,iz)=ts11(iz)
c
 300  continue
c
      U=0.5*U
c
      return
      end
